﻿// Test unit
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ConsoleApplication2.Test;

using F = NesterovskyBros.API.Functions;

#if DEBUG || TRACE
using System.Diagnostics;
#endif

[assembly:Copyright("(C) 2009")]
[assembly:Trademark("Nesterovsky bros")]

namespace My
{
  using MemoryStream = System.IO.MemoryStream;
  using HttpWebRequest = System.Net.HttpWebRequest;
  using WebRequest = System.Net.WebRequest;
  using MyObject = MyNamespace.MyObject;

  public class A: MyNamespace.C, MyNamespace.I
  {
    public A():
      base(1)
    {
      string j = @"one
two
three";

L:
      int i1 = 7;

      ++i1;

#if DEBUG
      Console.WriteLine(export.iefSupplied.command);
#elif TRACE
      Console.WriteLine(export.iefSupplied.command);
#endif

      if (i1 > 0)
      {
        return;
      }
      else if (i1 == 0)
      {
        throw new Exception();
      }

      var o1 = new MyObject();
      var o2 = new MyObject(i1);
      var o3 = new MyObject { A = i1 };
      var o4 = new MyObject(i1)
      {
        A = 0,
        B = 0,
        C = 0
      };

      var o5 = new { A = 0 };
      var a = new[]
      {
        o1,
        o2,
        o3,
        o4
      };

      switch(i1)
      {
        case 1:
        {
          goto case 2;
        }
        case 2:
        {
          break;
        }
        default:
        {
          return;
        }
      }

      while(i1 < 10)
      {
        ++i1;
      }

      do
      {
        ++i1;
      }
      while(i1 < 10);

      for(int j1 = 0; j1 < 100; ++j1)
      {
        Console.WriteLine(j1);
      }

      foreach(var i2 in Items())
      {
        if (i2 == 7)
        {
          return;
        }
        else
        {
          continue;
        }
      }

      lock(sync)
      lock(sync2)
      {
        process();
      }

      using(BeginScope())
      {
        return;
      }

      try
      {
        checked
        {
          ++i1;
        }

        unchecked
        {
          ++i1;
        }
      }
      catch(OverflowException e)
      {
        return 0;
      }
      finally
      {
        ++i1;
      }

      yield return this.items[i1];

      yield break;

      fixed(int* p = stackalloc int[100])
      {
        *intref = 1;
      }

      var anonymous =
      {
        A = 1,
        B = 2,
        C = 3
      };

      var query = from c in customers
        group c by c.Country into g
        select new { Country = g.Key, CustCount = g.Count() };

      F.DoSomething();
    }

    ~A()
    {
    }

    private int f1;

    [Obsolete]
    private volatile int f2;

    public void Handler(object value)
    {
    }

    public int m<T>(T t)
      where T: new()
    {
      base.m(t);

      return 1;
    }

    public string P
    {
      get
      {
        return "A";
      }
      set;
    }

    public abstract string P { get; }

    public abstract int this[int index] { get; internal protected set; }

    public event Event E;

    public static A operator +(A first, A second)
    {
      System.Delegate handler = new System.Delegate(Handler);

      return first.Add(second);
    }

    class C
    {
    }
  }

  public struct S: I
  {
    public S()
    {
    }

    private int f1;

    [Obsolete]
    private volatile int f2;

    public abstract int m<T>(T t)
      where T: new()
    {
      return 1;
    }

    public string P
    {
      get
      {
        return "A";
      }
      set;
    }

    public abstract string P { get; }

    public abstract int this[int index] { get; internal protected set; }

    public event Event E;

    public static A operator +(A first, A second)
    {
      return first.Add(second);
    }

    fixed int field[10];

    class C
    {
    }
  }

  public interface I
  {
    void A(int value);

    string Value { get; set; }
  }

  public enum E
  {
    A,
    B,
    C,

#if DEBUG
    D,
#endif
  }

  public delegate void Delegate(object P);

  namespace Test
  {
    using System;
    using System.Collections;

    /// <summary>
    ///   Returns a enumerator of powers of a specified number.
    /// </summary>
    /// <param name="number">A base value.</param>
    /// <param name="exponent">Number of iterations.</param>
    /// <returns>
    ///   <see cref="Object">
    ///   <para>
    ///     Returns a enumerator <c>NAME</c>.
    ///   </para>
    ///   <list>
    ///     <listheader>Header</listheader>
    ///     <value>d</value>
    ///   </list>
    /// </returns>
    /// <seealso cref="Exception"/>
    /// <remarks>
    ///   <code>
    /// while(counter++ &lt; exponent)
    /// {
    ///   // Display powers of 2 up to the exponent 8:
    ///   result = result * number;
    ///   yield return result;
    /// }
    ///     <para>This is a code sample.</para>
    ///   </code>
    /// </remarks>
    public class List
    {
      public static IEnumerable Power(int number, int exponent)
      {
        int counter = 0;
        int result = 0;

        while(counter++ < exponent)
        {
          result = result * number;

          yield return result;
        }
      }

#region Entry point
      static void Main()
      {
        // Display powers of 2 up to the exponent 8:
        foreach(int i in Power(2, 8))
        {
          if (i == 0)
          {
            throw new Exception();
          }

          Console.Write("{0} ", i);
        }
      }
#endregion
    }
  }

  public interface Variance<in T, out P, Q>
  {
    void X(T t);
  }

  public class Class1
  {
    int Increment(int value, int increment = 1)
    {
      return value + increment;
    }

    void Test()
    {
      // Regular call.
      Increment(7, 1);

      // Call with named parameter.
      Increment(value: 7, increment: 1);

      // Call with default.
      Increment(7);

      dynamic v = Increment(7);
    }

    private async System.Threading.Tasks.Task<byte[]> GetURLContentsAsync(
      string url)
    {
      var content = new MemoryStream();
      var request = (HttpWebRequest)WebRequest.Create(url);

      using(var response = await request.GetResponseAsync())
      using(var responseStream = response.GetResponseStream())
      {
        await responseStream.CopyToAsync(content);
      }

      return content.ToArray();
    }
  }
}
